From 394d0a9f1f241700f3806c3796bb45bbe6edae25 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Hugo=20Beauz=C3=A9e-Luyssen?= <beauze.h@gmail.com>
Date: Thu, 24 Nov 2011 11:52:44 +0100
Subject: [PATCH 3/3] dash: Avoid multiple lookups.

---
 modules/stream_filter/dash/mpd/MPD.cpp |   16 ++++++++++------
 modules/stream_filter/dash/mpd/MPD.h   |    6 ++++--
 2 files changed, 14 insertions(+), 8 deletions(-)

diff --git a/modules/stream_filter/dash/mpd/MPD.cpp b/modules/stream_filter/dash/mpd/MPD.cpp
index 69b4c05..cb8c7e0 100644
--- a/modules/stream_filter/dash/mpd/MPD.cpp
+++ b/modules/stream_filter/dash/mpd/MPD.cpp
@@ -60,24 +60,28 @@ std::vector<BaseUrl*>   MPD::getBaseUrls            ()
 }
 std::string             MPD::getMinBufferTime       () throw(AttributeNotPresentException)
 {
-    if(this->attributes.find("minBufferTime") == this->attributes.end())
+    AttributesMap::iterator     it = this->attributes.find("minBufferTime");
+    if( it == this->attributes.end())
         throw AttributeNotPresentException();
 
-    return this->attributes["minBufferTime"];
+    return it->second;
 }
 std::string             MPD::getType                () throw(AttributeNotPresentException)
 {
-    if(this->attributes.find("type") == this->attributes.end())
+    AttributesMap::iterator     it = this->attributes.find( "type" );
+    if( it == this->attributes.end() )
         throw AttributeNotPresentException();
 
-    return this->attributes["type"];
+    return it->second;
 }
 std::string             MPD::getDuration            () throw(AttributeNotPresentException)
 {
-    if(this->attributes.find("mediaPresentationDuration") == this->attributes.end())
+    AttributesMap::iterator     it = this->attributes.find("mediaPresentationDuration");
+
+    if( it == this->attributes.end())
         throw AttributeNotPresentException();
 
-    return this->attributes["mediaPresentationDuration"];
+    return it->second;
 }
 ProgramInformation*     MPD::getProgramInformation  () throw(ElementNotPresentException)
 {
diff --git a/modules/stream_filter/dash/mpd/MPD.h b/modules/stream_filter/dash/mpd/MPD.h
index 732d38b..207a62d 100644
--- a/modules/stream_filter/dash/mpd/MPD.h
+++ b/modules/stream_filter/dash/mpd/MPD.h
@@ -41,6 +41,8 @@ namespace dash
     {
         class MPD
         {
+            typedef std::map<std::string, std::string>      AttributesMap;
+
             public:
                 MPD         (std::map<std::string, std::string> attributes);
                 MPD         ();
@@ -57,8 +59,8 @@ namespace dash
                 void    addBaseUrl              (BaseUrl *url);
                 void    setProgramInformation   (ProgramInformation *progInfo);
 
-            private:
-                std::map<std::string, std::string>  attributes;
+            private:                
+                AttributesMap                       attributes;
                 std::vector<Period *>               periods;
                 std::vector<BaseUrl *>              baseUrls;
                 ProgramInformation                  *programInfo;
-- 
1.7.7.4

